package zpplet;

public abstract class ZUserConfig
	{
	/*
	 * A collection of global configuration parameters that the user
	 * might be able to control via an interface.
	 * 
	 * This should be the only point of contact for application-wide 
	 * configuration parameters (ZMachine for instance parameters).
	 */
	
	// interpreter numbers
	public final static int INTERP_DEC = 1;
	public final static int INTERP_APPLEIIE = 2;
	public final static int INTERP_MAC = 3;
	public final static int INTERP_AMIGA = 4;
	public final static int INTERP_ATARIST = 5;
	public final static int INTERP_MSDOS = 6;
	public final static int INTERP_C128 = 7;
	public final static int INTERP_C64 = 8;
	public final static int INTERP_APPLEIIC = 9;
	public final static int INTERP_APPLEIIGS = 10;
	public final static int INTERP_COCO = 11;
	
	public static int interpreter = INTERP_MSDOS; 
	public static int foreground = zpplet.system.ZColor.Z_LIGHTGRAY;
	public static int background = zpplet.system.ZColor.Z_BLACK;
	public static int v6scale = 3;
	public static boolean tandybit = false;
	
	public static int scrollback = 500; // for window 0; 0 = off

	// unscaled dimension of V6 screen
	public final static int STATIC_WIDTH = 320;
	public final static int STATIC_HEIGHT = 200;
	
	// font info
	public static String variablefont = "Serif";
	public static String fixedfont = "Monospaced";
	public static int fontsize = 18;
	public static String normalfont = variablefont;
	}
